import { IsInt, IsOptional } from 'class-validator';
import { Entity, OneToMany, PrimaryGeneratedColumn, TableInheritance } from 'typeorm';
import { Permission } from './Permission';

/**
 * Defines a admin user.
*/
@Entity()
@TableInheritance({ column: { name: "type", type: "varchar" } })
export abstract class Principal {
  /**
  * autogenerated unique id (primary key).
  */
  @PrimaryGeneratedColumn()
  @IsInt()
  id: number;

  /**
* permissions
*/
  @IsOptional()
  @OneToMany(() => Permission, permission => permission.principal, { nullable: true })
  permissions?: Permission[];
}